VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "DirectInput Sample"
   ClientHeight    =   5370
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6900
   LinkTopic       =   "Form1"
   ScaleHeight     =   5370
   ScaleWidth      =   6900
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00000000&
      Height          =   4935
      Left            =   120
      ScaleHeight     =   325
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   445
      TabIndex        =   0
      Top             =   360
      Width           =   6735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'~~~~~~~~~Variables used to track the program~~~~~~
'Mouse Coors
Dim x As Integer
Dim y As Integer
'Keyboard coors
Dim KeyBoardPress As String
Dim KeyboardX As Integer
Dim KeyboardY As Integer
'Joystick coors
Dim JoyX As Integer
Dim JoyY As Integer
'Is the app running or not
Dim blnEnd As Boolean

Private Sub Form_Load()

'The device states
Dim KeyboardState(0 To 255) As Byte
Dim MouseState As DIMOUSESTATE
Dim JoystickState As DIJOYSTATE

Show
DoEvents

'Call function to initialize GUID values
GUID_Initialize

'~~~~~~~~Main DirectDraw object~~~~~~~~
'NOTE: &H500 is the version of DirectInput
DirectInputCreateA ByVal App.hInstance&, &H500, di, Nothing

'~~~~~~~Create keyboard~~~~~~~~~~~~~~~~
di.CreateDevice GUID_SysKeyboard, Keyboard, Nothing
Keyboard.SetDataFormat c_dfDIKeyboard
Keyboard.SetCooperativeLevel hWnd, DISCL_FOREGROUND Or DISCL_NONEXCLUSIVE

'~~~~~~Create Mouse~~~~~~~~~~~~~~~~~~~~
di.CreateDevice GUID_SysMouse, Mouse, Nothing
Mouse.SetDataFormat c_dfDIMouse
Mouse.SetCooperativeLevel hWnd, DISCL_FOREGROUND Or DISCL_NONEXCLUSIVE

'~~~~Enumerate joysticks and create device~~~~~~~
di.EnumDevices DIDEVTYPE_JOYSTICK, AddressOf EnumerateJoysticks, ByVal 0&, DIEDFL_ATTACHEDONLY
If Not Joystick Is Nothing Then
    Joystick.SetDataFormat c_dfDIJoystick
    Joystick.SetCooperativeLevel hWnd, DISCL_FOREGROUND Or DISCL_NONEXCLUSIVE
End If

'~~~~~Aquire the devices~~~~~~
Keyboard.Acquire
Mouse.Acquire
If Not Joystick Is Nothing Then Joystick.Acquire

On Error Resume Next

'Hide the mouse cursor.
'Why? The DirectInput coordinates start out at
'0 while the mousepointer doesn't. Therefore we
'hide it and listen to DirectInput instead.

ShowCursor 0

'Loop until end
While Not blnEnd
    On Error Resume Next
    
    '~~~~~~~~~Device States~~~~~~~~~
    'Note: Make sure to aquire first
        
    Keyboard.GetDeviceState 256, KeyboardState(0)
    'Aquire keyboard in case of error
    If Err <> 0 Then Keyboard.Acquire
    
    Mouse.GetDeviceState Len(MouseState), MouseState
    If Err <> 0 Then Mouse.Acquire
    
    If Not Joystick Is Nothing Then
        Joystick.Poll
        Joystick.GetDeviceState Len(JoystickState), JoystickState
        If Err <> 0 Then Joystick.Acquire
    End If
    
    'Restart if there is an error
    On Error GoTo 0
    
    '~~~~~~~~~Check Keyboard State~~~~~~~~~~~~
    If (KeyboardState(DIK_LEFT) And &H80) <> 0 Then KeyBoardPress = "left"
    If (KeyboardState(DIK_UP) And &H80) <> 0 Then KeyBoardPress = "up"
    If (KeyboardState(DIK_DOWN) And &H80) <> 0 Then KeyBoardPress = "down"
    If (KeyboardState(DIK_RIGHT) And &H80) <> 0 Then KeyBoardPress = "right"
    
    'Quit if spacebar is pressed
    blnEnd = (KeyboardState(DIK_SPACE) And &H80) <> 0
    
    '~~~~~~~Update Keyboard Coordinates~~~~~~~~~~
    If KeyBoardPress = "left" Then
        KeyboardX = KeyboardX - 1
    End If
    If KeyBoardPress = "right" Then
        KeyboardX = KeyboardX + 1
    End If
    If KeyBoardPress = "up" Then
        KeyboardY = KeyboardY - 1
    End If
    If KeyBoardPress = "down" Then
        KeyboardY = KeyboardY + 1
    End If
    
    'Reset keyboard polling
    KeyBoardPress = ""
    
    Picture1.PSet (KeyboardX, KeyboardY), RGB(255, 0, 0)
    
    
    
    
    '~~~~~~Update Mouse Coordinates~~~~~~~~~~
    
    x = x + MouseState.lX
    y = y + MouseState.lY
    
    'Make sure mouse doesn't go out of bounds
    If x < 0 Then x = 0
    If x > 640 Then x = 640
    
    'If left button is pressed
    If MouseState.rgbButtons(0) = 128 Then
        Picture1.Circle (x, y), 15, RGB(255, 255, 255)
    End If
    'If right button is pressed
    If MouseState.rgbButtons(1) = 128 Then
        Picture1.Line (x - 50, y - 50)-(x, y), RGB(255, 255, 255), BF
    End If
    
    'Draw point where MousePointer is located
    Picture1.PSet (x, y), RGB(255, 255, 255)
    
    '~~~~~~~~Update Joystick coordinates~~~~~~~~
    
    If JoystickState.rgbButtons(0) = 128 Then
        Picture1.Circle (JoyX, JoyY), 15, RGB(0, 0, 255)
    End If
    
    If JoystickState.lX <= 1800 And JoystickState.lY >= 64328 Then
        JoyY = JoyY + 1
        JoyX = JoyX - 1
    End If
    If JoystickState.lX <= 4000 And JoystickState.lY <= 7265 Then
        JoyY = JoyY - 1
        JoyX = JoyX - 1
    End If
    If JoystickState.lX >= 62821 And JoystickState.lY <= 4000 Then
        JoyY = JoyY - 1
        JoyX = JoyX + 1
    End If
    If JoystickState.lX >= 62257 And JoystickState.lY >= 62509 Then
        JoyY = JoyY + 1
        JoyX = JoyX + 1
    End If
    If JoystickState.lY <= 4398 Then
        JoyY = JoyY - 1
    End If
    If JoystickState.lX <= 966 Then
        JoyX = JoyX - 1
    End If
    If JoystickState.lX >= 62309 Then
        JoyX = JoyX + 1
    End If
    If JoystickState.lY >= 62535 Then
        JoyY = JoyY + 1
    End If
    
    Picture1.PSet (JoyX, JoyY), RGB(255, 255, 0)
    
    DoEvents
Wend

blnEnd = True
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'~~~~~~~~Release Devices~~~~~~~~~~~~~~
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

If Not Joystick Is Nothing Then Joystick.Unacquire
Set Joystick = Nothing
Mouse.Unacquire
Set Mouse = Nothing
Keyboard.Unacquire
Set Keyboard = Nothing

'Destroy DirectInput Object
Set di = Nothing

'Unload form

'Show cursor
ShowCursor 1

Unload Me


End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
If Not blnEnd Then
    blnEnd = True
    Cancel = True
End If

End Sub
